#! /usr/bin/env python
#from SEP import *
import commands as cmd
import re,string
import sys, os
import os.path as path


import pyAddmodF


def run(maindir,nblock,dboc,dsx,osx):
	dirm = maindir + "/m/mF"
	dirdm = maindir + "/dm/dmF"
	dirs = maindir + "/s/sF"
	dirgg = maindir + "/gg/ggF"
	dirss = maindir + "/ss/ssF"
	dirrr = maindir + "/rr/rrF"
	bshot =1
	eshot = (nblock-1)*dboc
	
	# Step 0: Create initial model
	cmd1 = "Vel n1=200 n2=700 o1=0. o2=0. d1=10. d2=10. n3=1 d3=1 vc=0. > %sTotaliter1.H"%(dirm)	
	os.system(cmd1)
	os.system("echo 'label1=z label2=x' >> "+dirm+"Totaliter1.H")
	
	# Step 1: Copy all synthetic data into /rr/ 
	for i in range(bshot,eshot+1):
		shot = osx + (i-1)*dsx
		os.system("Math file1=syndat/F/sdF"+`shot`+".H exp='file1*-1.' > "+dirrr+`shot`+"iter1.H")
	
	# Step 2: Copy all rtm result into /dm/ 
	os.system("Math file1=20shots/rtm/rtmFTotal.H exp='file1*-1.' > "+dirdm+"Totaliter1.H")

	print 'osx,dsx',osx,dsx
	# Step 4: Loop shots  gg = Fdm        
	pyAddmodF.Forward(maindir,dirdm, dirgg, bshot,eshot,osx,dsx,1)
        	
	
	# Step 5: Calculate the alpha in Conjugate gradient
	alpha, beta, resid = pyAddmodF.DPcalCG(maindir,bshot,eshot,osx,dsx,1)	
	file = open(maindir+'/Reportsave.txt',"w")
	file.writelines("iter alpha beta residual \n")
	cmd1 = " 1 %s 0. %s \n "%(alpha, resid)
	file.writelines(cmd1);
	file.close()
	print 'alpha', alpha, resid

	#  Step 6: Update the residual files
	for i in range(bshot,eshot+1):
                shot = osx + (i-1)*dsx
                print 'residual update, iter', iter, 'shot', shot
                #  calculate your ss file ss=alpha*gg+beta*ss	
                C1 = "bin/updateAB.x alpha=%s cg=1 naxis=3 file1=%s%siter1.H outfile=%s%siter2.H >/dev/null"%(alpha,dirgg,shot,dirss,shot)
		os.system(C1)
			             
		#  update your current residual here  rr = rr+ss
		C1 = "bin/updateAB.x alpha=1.0 beta=1.0 naxis=3 file1=%s%siter1.H file2=%s%siter2.H outfile=%s%siter2.H >/dev/null"%(dirrr,shot,dirss,shot,dirrr,shot)
		os.system(C1)
		

	
	# Step 7: Update the model files
	# Calculate your new dm s=alpha*dm
	print 'update model, iter 1'
	C1 = "bin/updateAB.x alpha=%s cg=1 naxis=2 file1=%sTotaliter1.H outfile=%sTotaliter2.H >/dev/null"%(alpha,dirdm,dirs)	
	os.system(C1)  
	# Calculate your new m = m+s
	C1 = "bin/updateAB.x alpha=1.0 beta=1.0 naxis=2 file1=%sTotaliter1.H file2=%sTotaliter2.H outfile=%sTotaliter2.H >/dev/null"%(dirm,dirs,dirm)	
	os.system(C1)
	
	

	


