program SUMMING
! sums up to 10 files at a time 
! sums are added to file0, as output
! si1e and dimension of output file is the same as the input file
! input: nfile : number of files to be added
! input: naxis : number of axis in each file
! input: file0='...' file1=... file2=...  file10=...
! output: > name of file0


  use sep
  
  
  implicit none
  
  integer                   :: nfile, naxis, nvolume
  integer                   :: n1, n2, n3, n4, n5
  integer                   :: i
  real                      :: o1, o2, o3, o4, o5
  real                      :: d1, d2, d3, d4, d5
  character(len=128)        :: label1, label2, label3, label4, label5
  character(len=128)        :: outfile_, getfile_
  character(len=128)        :: file1_, file2_, file3_, file4_, file5_
  character(len=128)        :: file6_, file7_, file8_, file9_, file10_ 
  real, dimension(:), allocatable   :: sumArray, tempArray
  
  call sep_init()

  call from_param('nfile', nfile);
  call from_param("naxis",naxis);
  
  
  if (nfile .lt. 2) call erexit('Must sum at least 2 files')
  if (nfile .gt. 10) call erexit('Can only add up to 10 files')
  if ((naxis .gt. 5) .or. (naxis .lt. 1) ) call erexit('naxis must be between 1 to 5')
  
  call from_param('outfile',outfile_) 
  if (nfile .ge. 1) call from_param("file1", file1_);   
  if (nfile .ge. 2) call from_param("file2", file2_);
  if (nfile .ge. 3) call from_param("file3", file3_);
  if (nfile .ge. 4) call from_param("file4", file4_);
  if (nfile .ge. 5) call from_param("file5", file5_);
  if (nfile .ge. 6) call from_param("file6", file6_);
  if (nfile .ge. 7) call from_param("file7", file7_);
  if (nfile .ge. 8) call from_param("file8", file8_);
  if (nfile .ge. 9) call from_param("file9", file9_);      
  if (nfile .ge. 10) call from_param("file10", file10_);
    
  getfile_ = file1_

  
  n1=1.; n2=1.; n3=1.;  n4=1.; n5=1.;
  
  if(naxis .ge. 1) then
     call from_aux(getfile_, "n1", n1);    call from_aux(getfile_,"d1",d1);     call from_aux(getfile_, "o1",o1);
     call from_aux(getfile_, "label1",label1);
  end if
  
  if (naxis .ge. 2) then
     call from_aux(getfile_, "n2", n2);    call from_aux(getfile_,"d2",d2);     call from_aux(getfile_, "o2",o2);
     call from_aux(getfile_, "label2",label2);
  end if
  
  if(naxis .ge. 3) then
     call from_aux(getfile_, "n3", n3);    call from_aux(getfile_,"d3",d3,1.);     call from_aux(getfile_, "o3",o3,0.);
     call from_aux(getfile_, "label3",label3);
  end if
  
  if (naxis .ge. 4) then
     call from_aux(getfile_, "n4", n4);    call from_aux(getfile_,"d4",d4);     call from_aux(getfile_, "o4",o4);
     call from_aux(getfile_, "label4",label4);
  end if
  
  if (naxis .ge. 5) then
     call from_aux(getfile_, "n5", n5);    call from_aux(getfile_,"d5",d5);     call from_aux(getfile_, "o5",o5);
     call from_aux(getfile_, "label5",label5);
  end if
  
  
  nvolume=n1*n2*n3*n4*n5
  allocate(sumArray(nvolume), tempArray(nvolume))
  sumArray = 0.;
  tempArray = 0.;
 

  
  ! Adding with file 1
  if (nfile .ge. 1) then
     call sep_read(tempArray, file1_);
     write(0,*) 'adding file1', trim(file1_)
     do i=1,nvolume        
           sumArray(i) = sumArray(i) + tempArray(i);
           tempArray(i) = 0.;

     end do
   end if  


  ! Adding with file 2
  if (nfile .ge. 2) then
     call sep_read(tempArray, file2_);
     write(0,*) 'adding file2', trim(file2_)
     do i=1,nvolume        
           sumArray(i) = sumArray(i) + tempArray(i);
           tempArray(i) = 0.;

     end do
   end if  

  ! Adding with file 3
  if (nfile .ge. 3) then
     call sep_read(tempArray, file3_);
     write(0,*) 'adding file3', trim(file3_)
     do i=1,nvolume        
           sumArray(i) = sumArray(i) + tempArray(i);
           tempArray(i) = 0.;

     end do
   end if  

  ! Adding with file 4
  if (nfile .ge. 4) then
     call sep_read(tempArray, file4_);
     write(0,*) 'adding file4', trim(file4_)     
     do i=1,nvolume        
           sumArray(i) = sumArray(i) + tempArray(i);
           tempArray(i) = 0.;

     end do
   end if  

  ! Adding with file 5
  if (nfile .ge. 5) then
     call sep_read(tempArray, file5_);
     write(0,*) 'adding file5', trim(file5_)     
     do i=1,nvolume        
           sumArray(i) = sumArray(i) + tempArray(i);
           tempArray(i) = 0.;

     end do
   end if  


  ! Adding with file 6
  if (nfile .ge. 6) then
     call sep_read(tempArray, file6_);
     write(0,*) 'adding file6', trim(file6_)
     do i=1,nvolume        
           sumArray(i) = sumArray(i) + tempArray(i);
           tempArray(i) = 0.;

     end do
   end if  


  ! Adding with file 7
  if (nfile .ge. 7) then
     call sep_read(tempArray, file7_);
     write(0,*) 'adding file7', trim(file7_)
     do i=1,nvolume        
           sumArray(i) = sumArray(i) + tempArray(i);
           tempArray(i) = 0.;

     end do
   end if  


  ! Adding with file 8
  if (nfile .ge. 8) then
     call sep_read(tempArray, file8_);
     write(0,*) 'adding file8', trim(file8_)
     do i=1,nvolume        
           sumArray(i) = sumArray(i) + tempArray(i);
           tempArray(i) = 0.;

     end do
   end if  


  ! Adding with file 9
  if (nfile .ge. 9) then
     call sep_read(tempArray, file9_);
     write(0,*) 'adding file9', trim(file9_)
     do i=1,nvolume        
           sumArray(i) = sumArray(i) + tempArray(i);
           tempArray(i) = 0.;

     end do
   end if  


  ! Adding with file 10
  if (nfile .ge. 10) then
     call sep_read(tempArray, file10_);
     write(0,*) 'adding file10', trim(file10_)
     do i=1,nvolume        
           sumArray(i) = sumArray(i) + tempArray(i);
           tempArray(i) = 0.;

     end do
   end if  

  

  if (.true.) then
     if (naxis .ge. 1) then
         call auxputch("n1",'i',n1, trim(outfile_));     
         call auxputch("d1",'f',d1, trim(outfile_));   
         call auxputch("o1",'f',o1,trim(outfile_));
         call auxputch("label1",'s',label1,trim(outfile_));
     end if
     if (naxis .ge. 2) then
	  call auxputch("n2",'i',n2, trim(outfile_));     
	  call auxputch("d2",'f',d2, trim(outfile_));   
	  call auxputch("o2",'f',o2,trim(outfile_));
          call auxputch("label2",'s',label2,trim(outfile_));
     end if
     if (naxis .ge. 3) then
	  call auxputch("n3",'i',n3, trim(outfile_));     
	  call auxputch("d3",'f',d3, trim(outfile_));   
	  call auxputch("o3",'f',o3,trim(outfile_));
          call auxputch("label3",'s',label3,trim(outfile_));
     end if
     if (naxis .ge. 4) then
	  call auxputch("n4",'i',n4, trim(outfile_));     
	  call auxputch("d4",'f',d4, trim(outfile_));   
	  call auxputch("o4",'f',o4,trim(outfile_));
          call auxputch("label4",'s',label4,trim(outfile_));
     end if
     if (naxis .ge. 5) then
	  call auxputch("n5",'i',n5, trim(outfile_));     
	  call auxputch("d5",'f',d5, trim(outfile_));   
	  call auxputch("o5",'f',o5,trim(outfile_));
          call auxputch("label5",'s',label5,trim(outfile_));
     end if
  end if

   call sep_write(sumArray, outfile_);

   call sep_close()

end program
