program SecondDer

! Take Second derivative of input file
! Only along the first axis

  use sep
  use waveprop_mod
  use smooth_mod
  use type_mod

implicit none


 type(velo) :: mm


 integer    :: ix, iz, i3, nx, nz, n3
 real       :: nr
 real, dimension(:), allocatable  ::  temp
 real, dimension(:,:,:), allocatable :: model

 call sep_init()





  ! Read back ground mmocity param
   call from_history("n1", mm%z%n);  call from_history("d1", mm%z%d);  call from_history("o1",mm%z%o);
   call from_history("n2", mm%x%n);  call from_history("d2", mm%x%d);  call from_history("o2",mm%x%o);
   call from_history("n3", n3,1);

   nz = mm%z%n;
   nx = mm%x%n;

   
   allocate( model(nz,nx,n3), temp(nz))



   ! Read in the background mmocity
    call sep_read( model(1:nz,1:nx,1:n3))


if (1 == 1) then

   ! take 1st derivative of receiver wavefield
   do i3=1,n3     
     do ix=1,nx
      temp(:) = model(:,ix,i3)
      call SecDer(temp, temp, nz, mm%z%d)
      model(:,ix,i3) = temp(:)
     end do
   end do
   
!   do iz=1,nz
!        tempV2(:) = vp(iz,:)
!      call FirstDer(.true.,tempV2, tempV2, nx, mm%x%d)
!      vp(iz,:) = tempV2(:)
!   end do


end if


   
!----------------------------------------------
! Output

  call sep_write(model,dim1=nz, dim2=nx, dim3=n3, esize=4)
  
  call to_history("n1",mm%z%n); call to_history("d1",mm%z%d);  call to_history("o1",mm%z%o);
  call to_history("n2",mm%x%n); call to_history("d2",mm%x%d);  call to_history("o2",mm%x%o);
  call to_history("n3",n3)
  
  

end program
