!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!  convert picked traveltimes to ascii files
!!!  each shot will be saved in one different file, the shot number will be noted by a 5 digit number starting from 00000


program  characters
  use sep
!  use billgen
  implicit none
  integer                           ::ndim,nx,nsx,nsx2,i
  real                              ::ox,dx
  real                              ::sx,x,y,z,t,u
  real                              ::yrcv,zrcv,sigma
  real,dimension(:),allocatable     ::srcinfo 
  real,dimension(:,:),allocatable   ::picks 
  integer                           ::isx,ix,idx1,idx2,idxlen
  integer                           ::i1,i2,i3,i4,i5
  character*72                      ::ofname,tmpfname1
  character*10                      ::tmpfname2

  call initpar()
  call sep_init(SOURCE)
  
 
!  standard input is picked travel time, 
!  sfile is the source geometry info file
!  call from_history("n1",nx,1)
!  call from_history("o1",ox,1.)
!  call from_history("d1",dx,1.)
!  call from_history("n2",nsx,1)
!  call from_aux("sfile","n1",nsx2,1)
!  call from_aux("sfile","n2",ndim,1)
  

!  index length for numbering of shots, if idxlen=3 , shot number 1 will be represented as 001, number 12 as 012, number 111 as 111, etc..
  call from_param("idxlen",idxlen,5)
!  y,z coord of receivers, assume they're the same for all receivers
!  call from_param("yrcv",yrcv,0.)
!  call from_param("zrcv",zrcv,0.)
!  standard deviation of picked traveltime, assume all picking has the same standard deviation
!  call from_param("sigma",sigma,0.0)
!  if (ndim.ne.3) then
!     write(0,*)"Error may occur next due to ndim!=3!!!" 
!  end if    
!  if (nsx.ne.nsx2) then
!     write(0,*)"Error may occur next due to unequal number of shots!!!" 
!  end if   

  nsx=13

  nsx2=nsx 
!  allocate ( srcinfo(ndim*nsx), picks(nx,nsx) )
!  call sreed("sfile",srcinfo,ndim*nsx*4)
!  call sreed("in",picks,nx*nsx*4)

!  filename for output file
  ofname=' '
  call from_param("fout",ofname,"Souwfld")
  idx1=index(ofname,' ')-2 

!  for each shot,append the index number of shot to the end of ofname 
  do isx=1,nsx
     call i2a(isx,tmpfname2,idxlen)
     do i1=1,idxlen
        ofname(idx1+i1:idx1+i1) = tmpfname2(i1:i1)
     end do
     ofname(idx1+i1:idx1+i1+9)='.H'   
     ofname(idx1+i1+10:72)=' '   
     tmpfname1=' ' 
     tmpfname1=ofname
     write(*,*) trim(tmpfname1), ' hi'
!     i2=isx+10
!     open(unit=12, file=tmpfname1, status='unknown')
!     x=srcinfo(isx+2*nsx)
!     y=srcinfo(isx+nsx)
!     z=srcinfo(isx)
!     t=0.0
!     u=sigma
!     i=-1
!     write(12,5) x,y,z,t,u,i
!     do ix=3,nx-3
!        x=ox+(ix-1)*dx
!        y=yrcv
!        z=zrcv
!        t=picks(ix,isx)
!        u=sigma
!        i=1
!        write(12,5) x,y,z,t,u,i
!5       format(5f10.3,i3)
!     end do
!     close(unit=12)
  end do

end program 


subroutine i2a(input,output,idxlen)

  integer,intent(in)                   :: input,idxlen
  character(len=*),intent(out)         :: output
  integer                              :: i,j,k
  character(len=80)                    :: sbuf

  output=' '
  sbuf=' '
  k=1
  i=input
  do k=1,idxlen
     j=mod(i,10)
     sbuf(k:k)=achar(j+48)
     i=i/10
  end do
  k=idxlen
  do i=1,k
     output(i:i)=sbuf((k+1-i):(k+1-i))
  end do
  !write(*,*)"done with assigning",sbuf,k

end subroutine  
