program dotproduct
! Calculate the dot product of 2 files and output to screen

  use sep
  
  implicit none
  
  
  logical                 :: same
  integer                 :: n1, n2, n1aux, n2aux, ntotal
  integer                 :: i1, i2
  real*8                  :: dotval
  character(len=128)      :: file1_, file2_, outfile_
  real, dimension(:,:), allocatable    :: array1, array2
  
  
  call sep_init()
  
  call from_param('same', same, .false.)
  
  ! Read output txtfile
  call from_param('outtag', outfile_);
  
  ! Get info from file1
  call from_param('file1', file1_);    
  call from_aux(file1_, 'n1',n1);       call from_aux(file1_, 'n2', n2);
  
  ! Get info from file2
  if (.not. same)  then
    call from_param('file2', file2_);
    call from_aux(file2_, 'n1',n1aux);       call from_aux(file2_, 'n2', n2aux);
    ! check size of file1 and file2 is the same
    if ((n1aux .ne. n1) .or. (n2aux .ne. n2)) call erexit('size of file1 and file2 not match!');
  end if
  
 
   
  ! allocation and initialize the array
  allocate(array1(n1,n2))
  if (.not. same) allocate(array2(n1,n2))
  do i2=1,n2
    do i1=1,n1
       array1(i1,i2) = 0.
       if (.not. same) array2(i1,i2) = 0.
    end do
  end do
  
  ntotal = n1*n2
  
 
  call sep_read(array1, file1_)
  if (.not. same) call sep_read(array2, file2_)

  
  dotval=0.
  
  if (.not. same) then
     do i2=1,n2
     	do i1=1,n1
     	   dotval = dotval + array1(i1,i2)*array2(i1,i2)/ntotal
     	end do
     end do
  else
     do i2=1,n2
     	do i1=1,n1
     	   dotval = dotval + array1(i1,i2)*array1(i1,i2)/ntotal
     	end do
     end do
  end if
    
  
      
  call sep_close()
  

!   write(STDOUT,'(F5.3)') dotval
 
  
!  ! Write the dot product here
  OPEN(51,FILE=outfile_, ACCESS='APPEND')  
    write(51,*) dotval
  CLOSE(51)
  
  
  
  deallocate(array1)
  if (.not. same) deallocate(array2)


end program
