program modcgstep
! Instead of inputing r and dr. This program takes the value of the relevant dot product
! and calculate alpha and beta
! Input: rrdgg, ggdgg (if Forget=T)
! Input: ggdgg, ssdss, ssdrr, ssdgg, ggdrr,  (if Forget=F)
! Output: alpha,beta

  

  use sep
  
  implicit none
  
  
  logical                               :: Forget
  integer                               :: n1, n2, i1, i2
  integer                               :: n1aux, n2aux
  real                                  :: d1, d2, o1, o2, temp
  real*8                                  :: ggdgg, ssdgg, ssdss, ggdrr, ssdrr, gdr, sdr
  real*8                                  :: alpha, beta, determ
  character(len=128)                    :: outfile_

  
  call sep_init()
  
  
  call from_param('Forget', Forget, .true.)

  call from_param('ggdgg',temp);
  ggdgg = temp
  call from_param('ggdrr',temp);
  ggdrr = temp

  if (.not. Forget) then
      call from_param('ssdgg', temp);
      ssdgg=temp
      call from_param('ssdss', temp);
      ssdss=temp
      call from_param('ssdrr', temp);
      ssdrr=temp
  end if
  
  write(0,*) 'ggdrr, ggdgg, ssdss, ssdrr, ssdgg'
  write(0,*) ggdrr, ggdgg, ssdss, ssdrr, ssdgg
  
  ! obtain filename
  call from_param('outtag', outfile_);

  
  
  ! Calculate alpha and beta here
  if (Forget) then      ! steepest decent
     beta = 0.d0
     if (ggdgg .eq. 0) then
         call erexit('modcgstep: grad vanish identically')
     end if
     alpha = -ggdrr/ggdgg
  else
     if ((ggdgg .eq. 0.) .or. (ssdss .eq. 0.)) then
          alpha=0.;
          beta =0.;
     else
     	  sdr = -1.*ssdrr
     	  gdr = -1.*ggdrr
          determ = ggdgg*ssdss*max(1.d0 - (ssdgg/ggdgg)*(ssdgg/ssdss), 1.d-12)
!	  determ = ggdgg*ssdss-ssdgg*ssdgg
          alpha = (ssdss*gdr - ssdgg*sdr)/determ
          beta  = (-1.*ssdgg*gdr + ggdgg*sdr)/determ          
          write(0,*) 'determ, (ssdss*gdr - ssdgg*sdr)'
          write(0,*) determ, (ssdss*gdr - ssdgg*sdr)
     end if
  end if     


  ! Write the new alpha and beta to a file
  OPEN(53,FILE=outfile_, ACCESS='APPEND')  
     write(53,*) alpha
     if (.not. Forget) write(53,*) beta
  CLOSE(53)
  

  call sep_close()

end program
