module rtm_operDB
!! Note: Assume nrx = nx now ... not very general
!! Please add rec%x%d to LsqMig.f90

  use sep
  use type_modDB
  use waveprop_modDB
  use smooth_modDB

  implicit none

  logical, private                             :: verb, wfldout, deri
  integer, private                             :: bcOp, nsave, xsnap, istore
  integer, private                             :: nshot, nx, nz, nrx, nt, seed, nw, nnx, nnz
  integer, private                             ::  izs1, izs2, izr, ixr, irx, ixs, ishot, it
  integer, private                             :: nop, bndx, bndz, jsnap, ndata
  integer, dimension(:), allocatable, private  :: tapebd
  real*8, private                                :: dx, ox, dz, oz, dsx, osx, drx, orx, dt, ot
  real*8, private                                ::  zr, orz, drz, rho, maxv
  real*8, private                                :: c0, c1, c2, idx, idz, idt2, nr
  real*8, private                                :: xtapco, ztapco, delp
  real*8, dimension(:), allocatable,private      :: bndz0, bndz1, bndz2, bndx0, bndx1
  real*8, dimension(:), allocatable,private      :: xtaper, ztaper, fs, tempfr, tmpdata
  real*8, dimension(:,:), allocatable,private    :: vs1sq, vs2sq, vp2, tmpmodel, upmodel, dnmodel, ctaper, Wup
  real*8, dimension(:,:), allocatable,private    :: uo, um, up
  real*8, dimension(:,:), allocatable,private    :: uo1, um1, up1, uo2, um2, up2
  real*8, dimension(:,:,:), allocatable, private :: Ran1, Ran2, fr1, fr2
  real*8, dimension(:,:,:,:), allocatable,private  :: us1, us2,us
  real, dimension(:,:), allocatable, private     :: uuo
  character(len=128), private                  :: wfldsou1_, wfldsou2_, wfldrec_, wfldmod_, ssave_
  
  contains 

  integer function L_init(nshot_in, sou_in, rec_in, vel_in, fs_in, vp_in, rho_in, bc_in, &
		wfldsou_in, wfldrec_in, wfldmod_in, jsnap_in, verb_in, seed_in, velout_in) result(stat)


    optional ::  wfldsou_in, wfldrec_in, wfldmod_in, jsnap_in, verb_in

    type(sou_grid)       :: sou_in
    type(rec_grid)       :: rec_in
    type(velo)           :: vel_in
    type(bc_values)     :: bc_in

    logical              :: verb_in
    integer              :: nshot_in, ix, iz, jsnap_in, seed_in
    real*8                 :: rho_in
    real*8, dimension(:)   :: fs_in
    real*8, dimension(:,:) :: vp_in
    character(len=128)   :: wfldsou_in, wfldrec_in, wfldmod_in, velout_in

    nshot = nshot_in

    nx = vel_in%x%n
    dx = vel_in%x%d
    ox = vel_in%x%o
    nz = vel_in%z%n
    dz = vel_in%z%d
    oz = vel_in%z%o


    dsx = sou_in%x%d
    osx = sou_in%x%o
    nrx = rec_in%x%n
    orx = rec_in%x%o
    drx = rec_in%x%d
    zr = rec_in%z%o

    nt = rec_in%t%n
    dt = rec_in%t%d
    ot = rec_in%t%o


    bcOp = bc_in%Op
    bndx = bc_in%bndx
    bndz = bc_in%bndz
    nnx = nx - 2*bndx
    nnz = nz - 2*bndz
    nw = (vel_in%zw - oz)/dz + .5
    nop = bc_in%nop

    jsnap = jsnap_in
    seed = seed_in

    c0 = -30./12.
    c1 = +16./12.
    c2 = - 1./12.

! ********************
    xsnap = 1
    wfldsou2_ = 'SFor3b.H'
    deri = .true.
! ********************
    allocate(fs(nt), tempfr(nt), vp2(nz,nx)) 
    allocate(fr1(nshot,nrx,nt), fr2(nshot,nrx,nt))
    allocate(vs1sq(nz-nw,nx), vs2sq(nz+nw,nx))
	fr1=0.; fr2=0.;

    ! write(0,*) '** dim fr alloc', nshot, nx, nt, nrx

    ! Take 1st derivative of source function 
     write(0,*) 'Der of Sou wavefield'
     fs = fs_in
     call FirstDer(.true., fs ,fs ,nt,dt)
    

    !! Set up tapering coefficient if use absorbing boundary
    if (bcOp .eq. 1) then   
        xtapco = bc_in%xtapco
        ztapco = bc_in%ztapco
    end if

    
  !	write(0,*) 'jsnap is MODIFIED here'
 !   jsnap = 10

    if (present(wfldsou_in)) then
       wfldsou1_ = wfldsou_in
       wfldrec_ = wfldrec_in
       wfldmod_ = wfldmod_in
       wfldout = .true.
    end if


    if (present(verb_in)) verb = verb_in
       
    izs1 = bndz
    izs2 = bndz
  

    write(0,*) '*** what is bcOp', bcOp
 
    !----------------------------------------------------------------
    !! one-way absorbing BC and Tapersetup  
    allocate(bndz0(nx),bndz1(nx))      
    allocate(bndx0(nz),bndx1(nz))
    allocate(ztaper(bndz))
    allocate(xtaper(bndx))
    allocate(ctaper(bndz,bndx))
    if (bcOp .eq. 2) allocate(Ran1(nz,2*bndx,nshot), Ran2(2*bndz,nx-2*bndx,nshot))



    !----------------------------------------------------------------

   
    idx = 1./dx**2; idz = 1./dz**2; idt2= 1./dt**2
    
    
        call  abcsetup(nx,nz,vp2,dt,dx, dz, nop, bndz0,bndz1,bndx0,bndx1)      
!    call  tapersetup(bndz,bndx,ztapco,xtapco,ztaper,xtaper)
     call  tapersetupCos(bndz,bndx,ztaper,xtaper,ctaper)
    

    do ix=1,nx
       do iz=1,nz      
          vp2(iz,ix) = vp_in(iz,ix)*vp_in(iz,ix)
          vs2sq(iz+nw,ix) = vp2(iz,ix)    
       end do

       do iz=1,nw
          vs2sq(iz+bndz,ix) = vp2(iz+bndz,ix)
       end do

       do iz=1,nz-nw
          vs1sq(iz,ix) = vp_in(iz+nw,ix)*vp_in(iz+nw,ix)  
       end do

    end do


     do iz=1,bndz
	 vs1sq(   iz  ,:) = vs1sq( 1+bndz,:); vs1sq(nz-nw-iz+1,:) = vs1sq(nz-nw-bndz,:); 
	 vs2sq(   iz  ,:) = vs2sq( 1+bndz,:); vs2sq(nz+nw-iz+1,:) = vs2sq(nz+nw-bndz,:); 
	 vp2(   iz  ,:) = vp2( 1+bndz,:); vp2(nz-iz+1,:) = vp2(nz-bndz,:); 
     end do 


     do ix=1,bndx
        vs1sq(:,   ix  ) = vs1sq(:, 1+bndx); vs1sq(:,nx-ix+1) = vs1sq(:,nx-bndx); 
        vs2sq(:,   ix  ) = vs2sq(:, 1+bndx); vs2sq(:,nx-ix+1) = vs2sq(:,nx-bndx); 
        vp2(:,   ix  ) = vp2(:, 1+bndx); vp2(:,nx-ix+1) = vp2(:,nx-bndx); 
     end do






     ! Smoothing velocity model
      call triangle2(5, 5, nz-nw, nx, vs1sq, vs1sq)
      call triangle2(5, 5, nz-nw, nx, vs1sq, vs1sq)
      call triangle2(5, 5, nz-nw, nx, vs1sq, vs1sq)
      call triangle2(5, 5, nz-nw, nx, vs1sq, vs1sq)
      call triangle2(5, 5, nz-nw, nx, vs1sq, vs1sq)
      call triangle2(5, 5, nz-nw, nx, vs1sq, vs1sq)
      call triangle2(5, 5, nz+nw, nx, vs2sq, vs2sq)
      call triangle2(5, 5, nz+nw, nx, vs2sq, vs2sq)
      call triangle2(5, 5, nz+nw, nx, vs2sq, vs2sq)
      call triangle2(5, 5, nz+nw, nx, vs2sq, vs2sq)
      call triangle2(5, 5, nz+nw, nx, vs2sq, vs2sq)
      call triangle2(5, 5, nz+nw, nx, vs2sq, vs2sq)
      call triangle2(5, 5, nz, nx, vp2, vp2)
      call triangle2(5, 5, nz, nx, vp2, vp2)
      call triangle2(5, 5, nz, nx, vp2, vp2)
      call triangle2(5, 5, nz, nx, vp2, vp2)
      call triangle2(5, 5, nz, nx, vp2, vp2)
      call triangle2(5, 5, nz, nx, vp2, vp2)



   if (bcOp .eq. 2) then
        seed = 1000
        maxv = 3000.
        do ishot=1,nshot
  	  call rbcsetup(ishot, vp2, Ran1, Ran2, bndx, bndz, nx, nz, seed, maxv)
        end do
   end if
  


     
   !! Write out the velocity model
    if (exist_file("velout") ) then

         write(0,*) '%%% writing to velout', trim(velout_in)
         call auxputch("n1",'i',nz+nw,trim(velout_in));   
         call auxputch("d1",'f',dz,trim(velout_in));   call auxputch("o1",'f',oz,trim(velout_in));

         call auxputch("n2",'i',nx,trim(velout_in));   
         call auxputch("d2",'f',dx,trim(velout_in));   call auxputch("o2",'f',ox,trim(velout_in));

         write(0,*) 'size vp2', size(vp2) 

         if (bcOp .eq. 2) then
! ***** This need modification, tmpmodel(nz*nx) is now (nnz-nw by nx) ****** !
             tmpmodel(1:bndz,bndx+1:nx-bndx) = Ran2(1:bndz,1:nx-2*bndx,1);
	     tmpmodel(nz-bndz+1:nz,bndx+1:nx-bndx) = Ran2(bndz+1:2*bndz,1:nx-2*bndx,1);
	     tmpmodel(:,1:bndx) = Ran1(:,1:bndx,1);
	     tmpmodel(:,bndx+1:2*bndx) = Ran1(:,bndx+1:2*bndx,1);
	     tmpmodel(bndz+1:nz-bndz,bndx+1:nx-bndx) = vp2(:,:);
	     call srite(velout_in, tmpmodel);
         else

             call srite(velout_in, vs2sq, size(vs2sq)*4)
         end if

    end if

 

    write(0,*) 'allocating 6X', nz*nx
    allocate(uuo(nz,nx))
    allocate(up(nz,nx), um(nz,nx), uo(nz,nx))
    allocate(up1(nz-nw,nx), um1(nz-nw,nx), uo1(nz-nw,nx))
    allocate(up2(nz+nw,nx), um2(nz+nw,nx), uo2(nz+nw,nx))

    nsave = (nt)/xsnap
    write(0,*) 'allocating us', nz*nx*nsave*nshot
    allocate( us1(nz-nw,nx,nsave,nshot), us2(nz+nw,nx,nsave,nshot) )

    write(0,*) 'allocating 2X', nz*nx
    allocate(tmpmodel(nnz-nw,nnx), upmodel(nnz-nw,nnx), dnmodel(nnz-nw,nnx))
    allocate(Wup(nnz-nw,nnx),tapebd(nnx))
    
    tapebd = 45
    
    do ix=1,nnx
    	do iz=1,nnz-nw
		tmpmodel(iz,ix) = 0.;
		upmodel(iz,ix) = 0.;
		dnmodel(iz,ix) = 0.;
		Wup(iz,ix) = 1.;
	end do
    end do   	

   write(0,*) 'pass Wup check'
 
!   call WuptaperSetup(tapebd,10,Wup,nnz-nw,nnx)

!   call sep_write(Wup,'Wup.H',dim1=nnz-nw, dim2=nnx,esize=4)
   
! 	 call auxputch("n1",'i',nnz-nw,'Wup.H');   
!         call auxputch("d1",'f',dz,'Wup.H');   call auxputch("o1",'f',oz,'Wup.H');
!	 call auxputch("label1", 's', 'Z', 'Wup.H');
!
!         call auxputch("n2",'i',nnx,'Wup.H');   
!         call auxputch("d2",'f',dx,'Wup.H');   call auxputch("o2",'f',ox,'Wup.H');
!	 call auxputch("label2", 's', 'Z', 'Wup.H');
	 
    write(0,*) 'Wup', Wup(:,5)	 
!   call erexit('Exit here Check your Wup')

    ndata = nshot*nrx*nt
    allocate(tmpdata(ndata))

    ! Initialization
    tmpmodel=0
    !!! data_init should be commented out
  !!  call data_init(nz,nx,nsave,nshot, ssave_)




    ! -------------------------------------------------------------
    ! Pre-compute source wavefield

    us1=0.;  us2=0;
  


    do ishot=1,nshot
       
       ixs = bndx + 1 + ((osx+(ishot-1)*dsx) - ox)/dx

     
       up1=0.; um1=0.; uo1=0.;
       up2=0.; um2=0.; uo2=0.;

       ! Time loop - Pre-compute and store Source wavefields



       do it=1,nt



           !! 4th order laplacian
	   if (bcOp .eq. 1) then
              call laplac4(.true., um1, uo1,up1, vs1sq, dt, nx, nz-nw, idx, idz, nop)
              call laplac4(.true., um2, uo2,up2, vs2sq, dt, nx, nz+nw, idx, idz, nop)
           else
!              call laplac4RAN(ishot,um,uo,up,vp2,Ran1,Ran2,dt,nx,nz, bndx, bndz, idx,idz,2)
           end if

           !! time step
           um1 =   uo1
           uo1 =   up1
           um2 =   uo2
           uo2 =   up2


           ! Injecting source/rec wavefield into the finite diff grid
            uo1(izs1,ixs) =  uo1(izs1,ixs) + fs(it)  
	    uo2(izs2,ixs) = uo2(izs2,ixs) + fs(it)

           
           !! If absorbing boundary (bcOp .eq. 1) apply the operation here
           !! Else, let wavefield be scattered by random boundary (bcOp .eq. 1)
           if (bcOp .eq. 1) then
              !! taper
		
	       call taperingCos(nz-nw,nx,bndz,bndx,ztaper,xtaper,ctaper, uo1)
	       call taperingCos(nz-nw,nx,bndz,bndx,ztaper,xtaper,ctaper, up1)
	       call taperingCos(nz-nw,nx,bndz,bndx,ztaper,xtaper,ctaper, um1)
	       call taperingCos(nz+nw,nx,bndz,bndx,ztaper,xtaper,ctaper, uo2)
	       call taperingCos(nz+nw,nx,bndz,bndx,ztaper,xtaper,ctaper, up2)
	       call taperingCos(nz+nw,nx,bndz,bndx,ztaper,xtaper,ctaper, um2)

             !! Absorbing boundary
!             call absorbingBC1(nz,nx,nop,bndz0,bndz1,bndx0,bndx1,uo,um)
          end if


           ! Store source wavefield to memory for every xsnap time step
           if ((mod(it,xsnap) == 0) .or. (xsnap .eq. 1) ) then
              istore = it/xsnap
	      us1(:,:,istore,ishot) = uo1

	      us2(:,:,istore,ishot) = uo2
	     
           end if
      
 
           if (verb .and. (mod(it,50) .eq. 1)) then

              write(0,*) 'Sou: it, sum', it, sum(us1((bndz+1):(nnz-nw+bndz),:,istore,ishot)), sum(us2((bndz):(nnz+nw+bndz),:,istore,ishot))

           end if
        
             if(mod(it,jsnap)==0 .and. wfldout .and. ishot==1 ) then
!                  call sep_write(uo1,wfldsou1_)
!                  call sep_write(uo2,wfldsou2_)
!                       call sep_write(uo(bndz+1:nz-bndz,bndx+1:nx-bndx),wfldsou_)
             end if




       end do !(end source time loop)


     end do !(end shot time loop)


 if (1 == 2) then

 	   call auxputch("n1",'i',nz-nw,trim(wfldsou1_));
   	   call auxputch("d1",'f',dz,trim(wfldsou1_));   
           call auxputch("n2",'i',nx,trim(wfldsou1_));  
   	   call auxputch("d2",'f',dx,trim(wfldsou1_));   
   	   call auxputch("label1", 's', 'Z', trim(wfldsou1_));
     	   call auxputch("label2", 's', 'X', trim(wfldsou1_));
           call auxputch("n3",'i',nt/jsnap,trim(wfldsou1_));
           call auxputch("d3",'f', dt*jsnap, trim(wfldsou1_));   
  	   call auxputch("label3", 's', 'time', trim(wfldsou1_));

 	   call auxputch("n1",'i',nz+nw,trim(wfldsou2_));  
   	   call auxputch("d1",'f',dz,trim(wfldsou2_));   
           call auxputch("n2",'i',nx,trim(wfldsou2_));  
   	   call auxputch("d2",'f',dx,trim(wfldsou2_));  
   	   call auxputch("label1", 's', 'Z', trim(wfldsou2_));
     	   call auxputch("label2", 's', 'X', trim(wfldsou2_));
           call auxputch("n3",'i',nt/50,trim(wfldsou2_));   
           call auxputch("d3",'f', dt*jsnap, trim(wfldsou2_));   
  	   call auxputch("label3", 's', 'time', trim(wfldsou2_));

 end if

   ! --------------------------------------------------------------
 
    stat=0

  end function L_init

  !---------------------------------------------------------------------------
  !***************************************************************************
  !---------------------------------------------------------------------------
  integer function L_oper(adj, add, model, data) result(stat)


    logical, intent(in)         :: adj, add
    real*8, dimension(:)  :: model, data 

    
    integer                   :: ix, iz, iop, id, i
    integer                   :: i1,i2,i3,i4
    real*8                      :: datasum, frsum


    stat = 1

    write(0,*) 'L_oper pass1, adj', adj
    
    
    if (.not. add) then
       if (adj) then
          model = 0.
       else
          data=0.
       end if
    end if

        
    write(0,*) 'ztaper', sum(ztaper), sum(xtaper), sum(ctaper)
    
    if (adj) then      !!! ### RTM ### !!!



     ! Copy rec wavefield from 1D array to a 3D array
  
     

        tmpdata = data((ndata+1):(2*ndata))  
        fr2 = RESHAPE(tmpdata, (/nshot,nrx,nt/))    ! down going data
        tmpdata = data(1:ndata)      
	fr1 = RESHAPE(tmpdata, (/nshot,nrx,nt/))    ! upgoing data



	if (1 == 2) then
           ! take 1st derivative of receiver wavefield
            do irx=1,nrx
              do ishot=1,nshot
                if (irx*ishot .eq. 1) write(0,*) 'take derivative of Rec'
                tmpdata(1:nt) = fr1(ishot,irx,1:nt)
       	        call FirstDer(adj, tmpdata, tmpdata, nt, dt)
                fr1(ishot,irx,1:nt) = tmpdata(1:nt)
                        
                tmpdata(1:nt) = fr2(ishot,irx,1:nt)
       	        call FirstDer(adj, tmpdata, tmpdata, nt, dt)
                fr2(ishot,irx,1:nt) = tmpdata(1:nt)
              end do
           end do
        end if



      !! Initizalize the array
         tmpmodel=0.; upmodel=0.; dnmodel=0.;


     ! Shot loop
       do ishot=1,nshot
        

         

         !! initialize array
          up=0.; um=0.; uo=0.; 
          up2=0.; um2=0.; uo2=0.;


      
          do it=nt,1,-1
         
       
              !! 4th order laplacian
               call laplac4(adj, um, uo,up, vp2, dt, nx, nz, idx, idz, nop)
               call laplac4(adj, um2, uo2,up2, vp2, dt, nx, nz, idx, idz, nop)

              !! time step
                um =   uo                 
                uo =   up 
                um2 =   uo2
                uo2 =   up2


               !! taper
                    call taperingCos(nz,nx,bndz,bndx,ztaper,xtaper, ctaper, uo)
                    call taperingCos(nz,nx,bndz,bndx,ztaper,xtaper, ctaper, up)
                    call taperingCos(nz,nx,bndz,bndx,ztaper,xtaper, ctaper, um)
		    call taperingCos(nz,nx,bndz,bndx,ztaper,xtaper, ctaper, uo2)
		    call taperingCos(nz,nx,bndz,bndx,ztaper,xtaper, ctaper, up2)
		    call taperingCos(nz,nx,bndz,bndx,ztaper,xtaper, ctaper, um2)

              !! Absorbing boundary
!              call absorbingBC2(nz,nx,nop,bndz0,bndz1,bndx0,bndx1,uo,um)
    


             ! Inject receiver signal  
               izr= (zr-oz)/dz + 1.5 + bndz
               do irx=1,nrx
                   ixr = (orx+(irx-1)*drx -ox)/dx + 1.5 + bndx
                   uo(izr,ixr) = uo(izr,ixr) + fr1(ishot, irx, it)  
                   uo2(izr,ixr) = uo2(izr,ixr) + fr2(ishot, irx, it)  
               end do 





            !!! RTM: IMAGING CONDITION
            ! Multiply the source and receiver wavefield at each time step (zero lag)
 

             
             if ((xsnap .eq. 1) .or. (mod(it,xsnap) .eq. 0)) then
	        istore = it/xsnap
                do ix=1,nnx
                   do iz=1,(nnz-nw)
	              upmodel(iz,ix) = upmodel(iz,ix) + us1(iz+bndz,ix+bndx,istore,ishot)*uo(iz+bndz+nw,ix+bndx)
		      dnmodel(iz,ix) = dnmodel(iz,ix) + us2(iz+2*nw+bndz,ix+bndx,istore,ishot)*uo2(iz+bndz+nw,ix+bndx)
                      tmpmodel(iz,ix) = Wup(iz,ix)*upmodel(iz,ix) + dnmodel(iz,ix)
                   enddo
                enddo
             end if
                             
               if ((mod(it,50) .eq. 0)) write(0,*) 'adjoint it, sum uo', it, sum(upmodel), sum(dnmodel)    

!               if(mod(it,jsnap)==0 .and. wfldout .and. ishot==1 ) then
!                  call sep_write(uo,wfldrec_)
!		   call sep_write(upmodel,'upmodel.H',dim1=nnz-nw,dim2=nnx,esize=4)
!		   call sep_write(dnmodel,'dnmodel.H',dim1=nnz-nw,dim2=nnx,esize=4)
!                  call sep_write(uo2(1:nz+bndz,1:nx),wfldrec_,dim1=nz,dim2=nx,esize=4)
!                  call sep_write(tmpmodel(1:nnz-nw,1:nnx),wfldmod_)
!               end if
         

        enddo ! (end rec time loop)
     enddo ! (shot loop)



    else  !!! ### FORWARD Modelling ### !!!


      ! Copy reflectivity model from 1D array to 2D array
       tmpmodel = RESHAPE( model, (/nnz-nw,nnx/))
  
       ! take first derivative of the model
       if (1 == 2) then
         do ix=1,nnx
         	  tmpdata(1:(nnz-nw)) = tmpmodel(:,ix)
        	  call FirstDer(adj, tmpdata, tmpdata, nnz-nw, dz)
        	  tmpmodel(:,ix) = tmpdata(1:(nnz-nw))
         end do
       end if
  
      !! Rec Loop
       fr1=0.; fr2=0.;


      ! Shot loop
         do ishot=1,nshot
        
           !! Rec Loop + Imaging condition
           up=0.; um=0.; uo=0.; 
	   up2=0.; um2=0.; uo2=0.;



               do it=1,nt

		   if (bcOp .eq. 1) then
                    call taperingCos(nz,nx,bndz,bndx,ztaper,xtaper, ctaper, uo)
                    call taperingCos(nz,nx,bndz,bndx,ztaper,xtaper, ctaper, up)
                    call taperingCos(nz,nx,bndz,bndx,ztaper,xtaper, ctaper, um)
		    call taperingCos(nz,nx,bndz,bndx,ztaper,xtaper, ctaper, uo2)
		    call taperingCos(nz,nx,bndz,bndx,ztaper,xtaper, ctaper, up2)
		    call taperingCos(nz,nx,bndz,bndx,ztaper,xtaper, ctaper, um2)
		   end if

                   !! 4th order laplacian
                   call laplac4(adj, um, uo,up, vp2, dt, nx, nz, idx, idz, nop)
                   call laplac4(adj, um2, uo2,up2, vp2, dt, nx, nz, idx, idz, nop)

                   !! time step
                   um =   uo
                   uo =   up 
                   um2 =   uo2
                   uo2 =   up2
 
 !                  call absorbingBC2(nz,nx,nop,bndz0,bndz1,bndx0,bndx1,uo,um)
   

                   ! Forward modelling Injection
                   if ( (xsnap .eq. 1) .or. (mod(it,xsnap) .eq. 0) )then
		      istore = it/xsnap   
                      do ix=1,nnx
                         do iz=1,(nnz-nw)
                            uo(iz+nw+bndz,ix+bndx) = uo(iz+nw+bndz,ix+bndx) + us1(iz+bndz,ix+bndx,istore,ishot)*Wup(iz,ix)*tmpmodel(iz,ix) 
                            uo2(iz+nw+bndz,ix+bndx) = uo2(iz+nw+bndz,ix+bndx) + us2(iz+2*nw+bndz,ix+bndx,istore,ishot)*tmpmodel(iz,ix) 
	 
                         enddo
                      enddo

                   end if


                   !! Collect data
		     izr= (zr-oz)/dz + 1.5 + bndz
                     do irx=1,nrx
                        
                        ixr = (orx+(irx-1)*drx -ox)/dx + 1.5 + bndx
                        fr1(ishot, irx, it) = fr1(ishot, irx, it)  + uo(izr,ixr)
                        fr2(ishot, irx, it) = fr2(ishot, irx, it)  + uo2(izr,ixr)
                        if ( it .eq. 1) write(0,*) 'irx, ixr', irx, ixr
                     end do
                     
                     if ((mod(it,50) .eq. 1)) write(0,*) 'forward sum, it', sum(fr1(ishot,:,it)), sum(fr2(ishot,:,it)), it



!                  if(mod(it,jsnap)==0 .and. wfldout .and. ishot==1 ) then
!      	 	      write(0,*) 'output ur', it, sum(uo)
!			call sep_write(uo2,wfldrec_)
!                       call sep_write(uo(bndz+1:nz-bndz,bndx+1:nx-bndx),wfldrec_)
!                       call sep_write(tmpmodel(1:nnz-nw,1:nnx),wfldmod_)
!                  end if
                  


               end do ! (rec time loop)
        enddo ! (shot loop)



   end if



   ! ------------------------------------------------------

   
    

    if (.not. adj) then
           
       if (1 == 2) then
           ! take 1st derivative of receiver wavefield
            do irx=1,nrx
              do ishot=1,nshot
                if (irx*ishot .eq. 1) write(0,*) 'take derivative of Rec'
                tmpdata(1:nt) = fr1(ishot,irx,1:nt)
       	        call FirstDer(adj, tmpdata, tmpdata, nt, dt)
                fr1(ishot,irx,1:nt) = tmpdata(1:nt)
                        
                tmpdata(1:nt) = fr2(ishot,irx,1:nt)
       	        call FirstDer(adj, tmpdata, tmpdata, nt, dt)
                fr2(ishot,irx,1:nt) = tmpdata(1:nt)
              end do
           end do
        end if
       
    	ndata = nshot*nt*nrx
       write(0,*) 'cp data back', ndata, size(data), size(fr1)
       data(1:ndata) = RESHAPE(fr1,SHAPE=(/nshot*nt*nrx/))
       data((ndata+1):(2*ndata)) = RESHAPE(fr2,SHAPE=(/nshot*nt*nrx/))   
       
    else
    
       ! take first derivative of the model
       if (1 == 2) then
           do ix=1,nnx
       		  tmpdata(1:(nnz-nw)) = tmpmodel(:,ix)
       		  call FirstDer(adj, tmpdata, tmpdata, nnz-nw, dz)
       		  tmpmodel(:,ix) = tmpdata(1:(nnz-nw))
       	   end do
       end if  
             
       model = RESHAPE(tmpmodel,SHAPE=(/ (nnz-nw)*nnx /) )

       ! takes second derivative of the model before exit
!       do ix=1,nnx
!            tlast = model(1,ix)
!         do iz=2,nnz-nw-1
!            tcurrent = model(iz,ix)
!            model(iz,ix) = (-2*model(iz,ix)+ tlast + model(iz+1,ix))/dz
!            tlast = tcurrent
!         end do
!       end do
       
       


    end if

    



    stat =0

    end function

    !---------------------------------------------------------------------------
    !---------------------------------------------------------------------------
    integer function L_close() result(stat)

      stat=1

	write(0,*) 'dalloc 1'
      deallocate(fr1, fr2, fs, tempfr, vs2sq, vs1sq, vp2)

      	write(0,*) 'dalloc 2'
      deallocate(bndz0, bndz1)
	write(0,*) 'dalloc 3'
      deallocate(bndx0, bndx1)
	write(0,*) 'dalloc 4'
      deallocate(xtaper, ztaper, ctaper)
      
	write(0,*) 'dalloc 5'
      deallocate(um, up, uo)

	write(0,*) 'dalloc 6'
      deallocate(tmpmodel, upmodel, dnmodel)

        write(0,*) 'dealloc 7'
      deallocate(us1, us2)
            
       deallocate(tmpdata)
      stat=0

    end function L_close

end module
