module type_mod

public                      :: axis, dat_grid, mod_grid, velo, sou_grid, rec_grid, abc_values

!--------------------------------------------------
  !!.. define type for axes
  type axis 
    integer 					:: n		! total number
    real    					:: d		! spacing
    real    					:: o		! origin
    real, allocatable				:: all(:)  	! values
  end type

!---------------------------------------------------
  !!.. define data grid
  type dat_grid
    type(axis) :: w, h, xd
  end type
!---------------------------------------------------
  !!.. define model grid
  type mod_grid
    type(axis) :: z, sh, xm, ym, th
  end type

!----------------------------------------------------

  ! define vel
  type velo
    type(axis) :: z, x, y
    real       :: zw
  end type

!----------------------------------------------------

  ! define reflectivity
  type refl_grid
    type(axis) :: z, x, y
  end type

!----------------------------------------------------

  ! define sou grid
  type sou_grid
     type(axis) :: z, x, y, t
     real      :: zs
  end type 

!----------------------------------------------------

  ! define rec grid
  type rec_grid
     type(axis) :: z, x, y, t
 !    real       :: zr1, zr2
  end type 

!----------------------------------------------------

  ! define taper/padding type
  type bc_values
     logical        :: ashot, residout, wfldout, UDout, wfrout, wfmout
     integer        :: Op, nop, bndz, bndx, bndy, shotdir
     real           :: xtapco, ztapco
  end type
     

end module
